/* This is a simple demo project written for use with
 * the HI-TECH Software PICC18 PRO compiler. It may be compiled
 * and run on the Microchip PICDEM 2 PLUS DEMO BOARD.
 * Features demonstrated include driving the LCD display and
 * the A2D converter. 
 
 Additional files required for this demo are included in the
 PIC18\SAMPLES directories:
 DELAY\delay.c
 DELAY\delay.h
 LCD\lcd.c
 LCD\lcd.h
 */

#include <htc.h>
#include <stdio.h>
#include "lcd.h"

/* this is the maximum value of an A2D conversion. */
#define MAXVOLTAGE 5

void init(void){
	lcd_init(FOURBIT_MODE);
	ADON=1;	/* enable A2D converter */
	ADIE=0;	/* not interrupt driven */
	ADCON1=0;
	ADCON0=1;
}

volatile unsigned char outString[20];

void main(void){
	unsigned char last_value;
	unsigned char volts;
	unsigned char decivolts;
	

	init();
	lcd_puts("Starting...");

	while(1){
		GODONE=1;
		while(GODONE)continue;
		ADIF=0;
		if(ADRESH!=last_value)
		{
			volts=0;
			for(decivolts=(ADRESH*10*MAXVOLTAGE/255);decivolts>=10;decivolts-=10)
				volts++;
			lcd_clear();
			sprintf(outString, "A2D = %d.%d volts", volts, decivolts);
			lcd_puts(outString);
		}
		last_value=ADRESH;
	}
}

